*!* Objet : Connversion HTML en MHT
*!* Auteur : C.Chenavier
*!* Version : 1.00 - 18/04/2005
*!*
*!* oMHtml = CREATEOBJECT("MHTML", cSourceHtml) 
*!* oMHtml.Value contient alors la page complte avec ses images.

#DEFINE LF          CHR(10)
#DEFINE CR          CHR(13)
#DEFINE CR_LF       CR+LF

DEFINE CLASS MHTML AS COLLECTION
       
       cFrom = ''
       cHtml = ''
       cSujet = ''
       value = ''
       
       PROCEDURE Init
           LPARAMETER cHtml
           
           LOCAL I, cImg, oImg
           IF ATC("<html>", M.cHtml) > 0
              THIS.cHtml = M.cHtml
              I = 1
              M.cImg = STREXTRACT(M.cHtml,'<img','>', I, 1)
              DO WHILE NOT EMPTY(M.cImg)
                 M.cImg = ALLTRIM(STRTRAN(STREXTRACT(M.cImg,'src','', 1, 1), '='))
                 M.cDelim = IIF(AT(['], M.cImg) > 0, ['], ["])
                 M.cImg = SUBSTR(M.cImg, 2, AT(M.cDelim, M.cImg, 2)-2)
                 IF FILE(M.cImg)
                    IF EMPTY(THIS.GetKey(M.cImg))
                       THIS.Add(M.cImg, M.cImg)
                    ENDIF
                 ELSE
                    TRY
                       oImg = LOADPICTURE(M.cImg)
                       IF EMPTY(THIS.GetKey(M.cImg))
                          THIS.Add(M.cImg, M.cImg)
                       ENDIF
                    CATCH
                    ENDTRY
                 ENDIF
                 I = I + 1
                 M.cImg = STREXTRACT(M.cHtml,'<img','>', I, 1)
              ENDDO
           ENDIF
       ENDPROC


       FUNCTION Value_access
       
           LOCAL cID, cMHtml, cImages, cPicture, cExt
           
           M.cID = SYS(2015)
           M.cMHtml = "From: " + THIS.cFrom + CR_LF + ;
                      "Subject: " + THIS.cSujet + CR_LF + ;
                      "Date: " + TTOC(DATETIME()) + CR_LF + ;
                      "MIME-Version: 1.0" + CR_LF + ;
                      "Content-Type: multipart/related;" + CR_LF + ;
                      [    type="text/html";] + CR_LF + ;
                      [    boundary="] + M.cID + ["] + CR_LF + CR_LF + ;
                      "--" + M.cID + CR_LF + ;
                      "Content-Type: text/html;" + CR_LF + ;
                      [    charset="Windows-1252"] + CR_LF + ;
                      "Content-Transfer-Encoding: quoted-printable" + CR_LF + CR_LF + ;
                      [<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">] + CR_LF + ;
                      STRTRAN(THIS.cHtml,"=","=3D") + CR_LF + CR_LF

           M.cImages = ''
           FOR EACH M.cPicture IN THIS
               M.cExt = LOWER(JUSTEXT(M.cPicture))
               IF M.cExt = "jpg"
                  M.cExt = "jpeg"
               ENDIF
               M.cImages = M.cImages  + ;
                           "--" + M.cID + CR_LF + ;
                           "Content-Type: image/" + M.cExt + CR_LF + ;
                           "Content-Transfer-Encoding: base64" + CR_LF + ;
                           "Content-Location: file:///" + M.cPicture + CR_LF + CR_LF + ;
                           Split(STRCONV(FILETOSTR(M.cPicture),13), 76) + CR_LF + CR_LF
           ENDFOR
           
           RETURN M.cMHtml + M.cImages + "--" + M.cID + "--"
       ENDFUNC
ENDDEFINE



*---------------------------------------------------------------- Split

FUNCTION Split

LPARAMETERS cString, nSize, cParseChar

LOCAL I, cRes

M.cRes = ''
IF PCOUNT() = 2
   M.cParseChar = CR_LF
ENDIF
FOR I = 1 TO CEILING(LEN(M.cString)/M.nSize)
    M.cRes = M.cRes + IIF(NOT EMPTY(M.cRes), M.cParseChar, '') + SUBSTR(M.cString, (I-1)*M.nSize + 1, M.nSize)
ENDFOR

RETURN M.cRes


